Attribute VB_Name = "mFormMove"

Option Explicit
Private Const SPI_GETWORKAREA = 48
Private Const SWP_NOMOVE = &H2
Private Const SWP_NOSIZE = &H1
Private Const SWP_NOZORDER = &H4
Private Const SWP_FLAGS = SWP_NOSIZE Or SWP_NOZORDER
Private Const SNAP_WIDTH As Integer = 8
Public Const Flags = SWP_NOMOVE Or SWP_NOSIZE

Private Type POINTAPI
        X As Long
        Y As Long
End Type

Private Type RECT
      Left As Long
      Top As Long
      Right As Long
      Bottom As Long
End Type
Private Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
Public Declare Function ReleaseCapture Lib "user32" () As Long
Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function SetWindowPos Lib "user32" (ByVal hWnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long
Private Declare Function GetWindowRect Lib "user32" (ByVal hWnd As Long, lpRect As RECT) As Long
Public Declare Function SystemParametersInfo Lib "user32.dll" Alias "SystemParametersInfoA" (ByVal uAction As Long, ByVal uParam As Long, lpvParam As Any, ByVal fuWinIni As Long) As Long
Public FMove As Boolean
Public lngReturnValue As Long

'Abstand ab wann die Form "einschnappt".
Public MoveForm As Boolean
Private XDif As Integer
Private YDif As Integer
Private Points() As RECT
Private ClX As Integer
Private ClY As Integer
Private scrRECT As RECT

Public Function StayOnTop(TheForm As Form)

      Dim SetWinOnTop As Long
      SetWinOnTop = SetWindowPos(TheForm.hWnd, HWND_TOPMOST, 0, 0, 0, 0, Flags)

End Function

Public Sub stopDrag()

      FMove = False

End Sub

Public Sub dragFrm(hWnd As Long)

      Dim R As RECT
      Dim p As POINTAPI
      Dim fX As Integer
      Dim fY As Integer
      Dim cx As Integer
      Dim cy As Integer
      Dim oX As Integer
      Dim oY As Integer
      Dim i As Integer
      Dim X As Integer
      Dim Y As Integer
      Dim foundEdge As Boolean
      GetCursorPos p
      X = p.X
      Y = p.Y
      Call GetWindowRect(hWnd, R)

      If FMove Then
            cx = X - XDif
            cy = Y - YDif
            fX = R.Left + cx
            fY = R.Top + cy

            'Sieht schlimmer aus, als es ist... (c:

            'Erluterung zu den Kommentaren:
            'z.B. Links-Rechts bedeutet: Die linke Seite der eigenen
            'Form an der rechten Seite des anderen Objektes.
            For i = 0 To UBound(Points)
                  'Links-Rechts

                  If (R.Left >= (Points(i).Right - SNAP_WIDTH) And R.Left _
                     <= (Points(i).Right + SNAP_WIDTH)) And (cx >= _
                     -SNAP_WIDTH And cx <= SNAP_WIDTH) And ((R.Top <= _
                     Points(i).Bottom) And (R.Bottom >= Points(i).Top) And _
                     Not (R.Left + SNAP_WIDTH >= scrRECT.Right)) Then
                        oX = fX
                        fX = Points(i).Right
                        XDif = XDif + (oX - X) + ClX
                        foundEdge = True
                        Exit For
                        'Rechts-Rechts
                  ElseIf R.Right >= (Points(i).Right - SNAP_WIDTH) And _
                     R.Right <= (Points(i).Right + SNAP_WIDTH) And _
                     cx >= -SNAP_WIDTH And cx <= SNAP_WIDTH And _
                     ((R.Top <= Points(i).Bottom) And (R.Bottom >= _
                     Points(i).Top)) Then
                        oX = fX
                        fX = Points(i).Right - (R.Right - R.Left)
                        XDif = XDif + (oX - X) + ClX
                        foundEdge = True
                        Exit For
                        'Links-Links
                  ElseIf (R.Left >= (Points(i).Left - SNAP_WIDTH) And _
                     R.Left <= (Points(i).Left + SNAP_WIDTH)) And _
                     (cx >= -SNAP_WIDTH And cx <= SNAP_WIDTH) And _
                     ((R.Top <= Points(i).Bottom) And (R.Bottom >= _
                     Points(i).Top)) Then
                        oX = fX
                        fX = Points(i).Left
                        XDif = XDif + (oX - X) + ClX
                        foundEdge = True
                        Exit For
                        'Rechts-Links
                  ElseIf R.Right >= (Points(i).Left - SNAP_WIDTH) And _
                     R.Right <= (Points(i).Left + SNAP_WIDTH) And _
                     cx >= -SNAP_WIDTH And cx <= SNAP_WIDTH And _
                     ((R.Top <= Points(i).Bottom) And (R.Bottom >= _
                     Points(i).Top) And Not (R.Right - SNAP_WIDTH _
                     <= scrRECT.Left)) Then
                        oX = fX
                        fX = Points(i).Left - (R.Right - R.Left)
                        XDif = XDif + (oX - X) + ClX
                        foundEdge = True
                        Exit For
                  End If
            Next i

            If Not foundEdge Then XDif = X
            foundEdge = False
            For i = 0 To UBound(Points)
                  'Oben-Unten

                  If (R.Top >= (Points(i).Bottom - SNAP_WIDTH) And R.Top _
                     <= (Points(i).Bottom + SNAP_WIDTH)) And (cy >= _
                     -SNAP_WIDTH And cy <= SNAP_WIDTH) And ((R.Left <= _
                     Points(i).Right) And (R.Right >= Points(i).Left) And _
                     Not (R.Top + SNAP_WIDTH >= scrRECT.Bottom)) Then
                        oY = fY
                        fY = Points(i).Bottom
                        YDif = YDif + (oY - Y) + ClY
                        foundEdge = True
                        Exit For
                        'Unten-Unten
                  ElseIf R.Bottom >= (Points(i).Bottom - SNAP_WIDTH) And _
                     R.Bottom <= (Points(i).Bottom + SNAP_WIDTH) And _
                     cy >= -SNAP_WIDTH And cy <= SNAP_WIDTH And _
                     ((R.Left <= Points(i).Right) And (R.Right >= _
                     Points(i).Left)) Then
                        oY = fY
                        fY = Points(i).Bottom - (R.Bottom - R.Top)
                        YDif = YDif + (oY - Y) + ClY
                        foundEdge = True
                        Exit For
                        'Oben-Oben
                  ElseIf (R.Top >= (Points(i).Top - SNAP_WIDTH) And _
                     R.Top <= (Points(i).Top + SNAP_WIDTH)) And _
                     (cy >= -SNAP_WIDTH And cy <= SNAP_WIDTH) And _
                     ((R.Left <= Points(i).Right) And (R.Right >= _
                     Points(i).Left)) Then
                        oY = fY
                        fY = Points(i).Top
                        YDif = YDif + (oY - Y) + ClY
                        foundEdge = True
                        Exit For
                        'Unten-Oben
                  ElseIf R.Bottom >= (Points(i).Top - SNAP_WIDTH) And _
                     R.Bottom <= (Points(i).Top + SNAP_WIDTH) And _
                     cy >= -SNAP_WIDTH And cy <= SNAP_WIDTH And _
                     ((R.Left <= Points(i).Right) And (R.Right >= _
                     Points(i).Left) And Not (R.Bottom - SNAP_WIDTH _
                     <= scrRECT.Top)) Then
                        oY = fY
                        fY = Points(i).Top - (R.Bottom - R.Top)
                        YDif = YDif + (oY - Y) + ClY
                        foundEdge = True
                        Exit For
                  End If
            Next i

            If Not foundEdge Then YDif = Y
            Call SetWindowPos(hWnd, 0&, fX, fY, 0&, 0&, SWP_FLAGS)
      End If
End Sub

Public Sub startDrag(hWnd As Long)

      Dim p As POINTAPI
      Dim rF As RECT
      Dim frm As Form
      Dim i As Integer
      FMove = True
      ReDim Points(0)
      'Desktopgre ohne die Taskleiste ermitteln...
      Call SystemParametersInfo(SPI_GETWORKAREA, vbNull, scrRECT, 0)
      Points(0) = scrRECT
      i = 1
      'RECTs der Forms ermitteln.
      For Each frm In Forms

            If (Not hWnd = frm.hWnd) And frm.Visible = True Then
                  ReDim Preserve Points(0 To i)
                  GetWindowRect frm.hWnd, Points(i)
                  i = i + 1
            End If
      Next frm

      Call GetCursorPos(p)
      XDif = p.X
      YDif = p.Y
      Call GetWindowRect(hWnd, rF)
      ClX = p.X - rF.Left
      ClY = p.Y - rF.Top
End Sub



